package edu.umd.dawn.common.annotations;

import java.lang.annotation.Annotation;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.reflect.MethodSignature;

public class Utils<T> {

    public static String getFullDescriptor(ProceedingJoinPoint jointPoint) {
        String className = ((MethodSignature) jointPoint.getSignature()).getDeclaringTypeName();
        String methodName =
                ((MethodSignature) jointPoint.getSignature()).getMethod().getName();
        return className + "." + methodName;
    }

    public static <T extends Annotation> T grabAnnotation(ProceedingJoinPoint jointPoint, Class<T> clazz) {
        return ((MethodSignature) jointPoint.getSignature()).getMethod().getAnnotation(clazz);
    }
}
